# composite.c File Reference

`#include "wand/studio.h"`
`#include "wand/MagickWand.h"`
`#include "wand/mogrify-private.h"`

## Data Structures
struct | _CompositeOptions
## Defines
#define | NotInitialized (unsigned int) (~0)
#define | DestroyComposite()
#define | ThrowCompositeException(asperity, tag, option)
#define | ThrowCompositeInvalidArgumentException(option, argument)
## Typedefs
typedef struct _CompositeOptions | CompositeOptions
## Functions
static MagickBooleanType | CompositeImageList (ImageInfo *image_info, Image **image, Image *composite_image, CompositeOptions *composite_options, ExceptionInfo *exception)
static void | CompositeUsage (void)
static void | GetCompositeOptions (CompositeOptions *composite_options)
static void | RelinquishCompositeOptions (CompositeOptions *composite_options)
WandExport MagickBooleanType | CompositeImageCommand (ImageInfo *image_info, int argc, char **argv, char **metadata, ExceptionInfo *exception)

## Define Documentation

#define DestroyComposite | ( |  | ) |

Value:

    { \
      RelinquishCompositeOptions(&composite_options); \
      for ( ; k >= 0; k--) \
        image_stack[k]=DestroyImageList(image_stack[k]); \
      for (i=0; i < (long) argc; i++) \
        argv[i]=DestroyString(argv[i]); \
      argv=(char **) RelinquishMagickMemory(argv); \
    }

#define NotInitialized (unsigned int) (~0)

#define ThrowCompositeException | ( | asperity,
|  | tag,
|  | option |  | ) |

Value:

    { \
      (void) ThrowMagickException(exception,GetMagickModule(),asperity,tag,"`%s'", \
         option == (char *) NULL ? strerror(errno) : option); \
      DestroyComposite(); \
      return(MagickFalse); \
    }

#define ThrowCompositeInvalidArgumentException | ( | option,
|  | argument |  | ) |

Value:

    { \
      (void) ThrowMagickException(exception,GetMagickModule(),OptionError, \
        "InvalidArgument","`%s': %s",argument,option); \
      DestroyComposite(); \
      return(MagickFalse); \
    }

## Typedef Documentation

typedef struct _CompositeOptions CompositeOptions

## Function Documentation

WandExport MagickBooleanType CompositeImageCommand | ( | ImageInfo * | image_info,
|  | int | argc,
|  | char ** | argv,
|  | char ** | metadata,
|  | ExceptionInfo * | exception |
| ) |  |  |

static MagickBooleanType CompositeImageList | ( | ImageInfo * | image_info,
|  | Image ** | image,
|  | Image * | composite_image,
|  | CompositeOptions * | composite_options,
|  | ExceptionInfo * | exception |
| ) |  |  | `[static]`

static void CompositeUsage | ( | void |  | ) | `[static]`

static void GetCompositeOptions | ( | CompositeOptions * | composite_options | ) | `[static]`

static void RelinquishCompositeOptions | ( | CompositeOptions * | composite_options | ) | `[static]`